AppTitle("Xeres' Demo: Vortex")
Global gfx_w=800, gfx_h=700 ; gfx_w=1280, gfx_h=720 ;
Graphics3D(gfx_w, gfx_h, 32, 2)
SetBuffer(BackBuffer())
SeedRnd(MilliSecs())
HidePointer()

Const KEY_ESC = 1
Local FrameTimer = CreateTimer(60)

Global camera = CreateCamera(), ms
CameraFogMode(camera, True)
CameraFogRange(camera, 8, 128)
CameraClsMode(camera, False, True)
PositionEntity(camera,0,0,+8)

Global Mesh = CreateMesh()
EntityFX(Mesh, 1+2+32) ;1+2+16+32
Global Surface = CreateSurface(Mesh)

Const VperRingMax = 36
Type TRing
	Field Vertex[VperRingMax]
End Type

Const RingMax = 64
Dim Ringe.TRing(RingMax)

Local i, c=255
For i=0 To RingMax
	Ringe(i)=CreateRing(i, 1.4, (i Mod 2)=0)
	ColorRing(Ringe(i), c,c,c)
	c=c-4
Next

UpdateNormals(Mesh) 
WireFrame(True)

Local Musik = LoadSound("Data/Anitek_-_05_-_Light-year.mp3")
Local MChan = PlaySound(Musik)

ms = MilliSecs()
Local Timer[8], dauer[8], modus=0, endtimes=0
Timer[0] = ms + 2500 : dauer[0]=800
Timer[1] = ms + 15000 : dauer[1]=1500
Timer[2] = ms + 25000: dauer[2]=25000

Local clsC%[3]

Repeat
	
	ms = MilliSecs()
	
	If endtimes=False Then
		MoveEntity(camera, 0, 0, 0.0001)
		TurnEntity(Mesh, 0, 0, -.1)
	EndIf
	
	DoColor(clsC)
	
	If Timer[0] < ms And endtimes=False Then
		Timer[0] = ms+dauer[0]
		If dauer[0]=>100 Then dauer[0]=dauer[0]-10
		ColorRing(Ringe(Rand(0, RingMax)), Col(), Col(), Col())
	EndIf
	
	If Timer[1] < ms And endtimes=False Then
		Timer[1] = ms+dauer[1]
		If dauer[1]=>1000 Then dauer[1]=dauer[1]-10
		ColorLine(Rand(0, VperRingMax-1), Col(), Col(), Col())
	EndIf
	
	If Timer[2] < ms And endtimes=False Then
		Timer[2] = ms+dauer[2]
		If dauer[2]=>10000 Then dauer[2]=dauer[2]-2000
		c=255
		For i=0 To RingMax
			Select modus
				Case 0: ColorRing(Ringe(i), c, c, Col())
				Case 1: ColorRing(Ringe(i), c, Col(), c)
				Case 2: ColorRing(Ringe(i), Col(), c, c)
				Case 3: ColorRing(Ringe(i), c, c, c)
			End Select
			c=c-4
		Next
		modus=(modus+1)Mod 4
		If ChannelPlaying(MChan)=False Then 
			endtimes=True
			Timer[5]=ms+8000
			Local Cend%[3], k
			For i=0 To RingMax
				ColorRing(Ringe(i), Cend[0], Cend[1], Cend[2])
				For k=0 To RingMax-i
					DoColor(Cend)
				Next
			Next
		EndIf
		Cls
	EndIf
	
	If endtimes=True And Timer[5] < ms Then Credits() : Exit
	
	RenderWorld()
	
	Flip(0)
	WaitTimer(FrameTimer)
Until AnyKey() Or MouseHit(1)
End

Function AnyKey()
	Local i%
	For i=0 To 255 
		If KeyHit(i) Then Return True
	Next
	Return False
End Function

Function CreateRing.TRing(z#, l#, swap)
	Local Ring.TRing = New TRing
	Local OldRing.TRing = Before Ring
	Local i, v, x#, y#
	For i=0 To 359 Step 360/VperRingMax
		x = Cos(i+(swap*180/VperRingMax))*l
		y = Sin(i+(swap*180/VperRingMax))*l
		Ring\Vertex[v]=AddVertex(Surface, x, y, z)
		;VertexColor(Surface, Ring\Vertex[v], Col(), Col(), Col())
		
		;If OldRing <> Null And v<VperRingMax Then
			;AddTriangle(Surface, Ring\Vertex[v], OldRing\Vertex[v], OldRing\Vertex[(v+1) Mod VperRingMax])
		;	AddTriangle(Surface, Ring\Vertex[v], OldRing\Vertex[v], OldRing\Vertex[(v-1+VperRingMax) Mod VperRingMax])
		;EndIf
		
		v=v+1
	Next
	
	If OldRing <> Null Then
		For v=0 To VperRingMax-1
			If swap Then
				AddTriangle(Surface, Ring\Vertex[v], OldRing\Vertex[v], OldRing\Vertex[(v-1+VperRingMax) Mod VperRingMax])
			Else
				AddTriangle(Surface, Ring\Vertex[(v-1+VperRingMax) Mod VperRingMax], OldRing\Vertex[v], OldRing\Vertex[(v-1+VperRingMax) Mod VperRingMax])
			EndIf	
		Next
	EndIf
	
	
	
	Return Ring
End Function

Function ColorRing(ring.TRing, r, g, b)
	Local i
	For i=0 To VperRingMax
		VertexColor(Surface, ring\Vertex[i], r, g, b)
	Next	
End Function

Function ColorLine(nr, r, g, b)
	Local i
	For i=0 To RingMax
		VertexColor(Surface, Ringe(i)\Vertex[nr], r, g, b)
	Next
End Function

Function Col()
	Return Rand(0,32)*8
End Function

Function DoColor(clsC%[3])
	;ClsColor(clsC[0],clsC[1],clsC[2])
	Local size=8
	Select clsC[3]
		Case 0
			clsC[0]=clsC[0]+size
			If clsC[0]>200 Then clsC[3]=1
		Case 1
			clsC[1]=clsC[1]+size
			If clsC[1]>200 Then clsC[3]=2
		Case 2
			clsC[2]=clsC[2]+size
			If clsC[2]>200 Then clsC[3]=3
		Case 3
			clsC[0]=clsC[0]-size
			clsC[1]=clsC[1]-size
			If clsC[0]<10 Then clsC[3]=4
		Case 4
			clsC[1]=clsC[1]+size
			clsC[2]=clsC[2]-size
			If clsC[2]<10 Then clsC[3]=5
		Case 5
			clsC[0]=clsC[0]+size
			clsC[1]=clsC[1]-size
			If clsC[0]>200 Then clsC[3]=6
		Case 6
			clsC[0]=clsC[0]-size
			clsC[2]=clsC[2]+size
			If clsC[0]<10 Then clsC[3]=7
		Case 7
			clsC[2]=clsC[2]-size
			If clsC[0]<10 Then clsC[3]=0
	End Select
	CameraFogColor(camera, clsC[0],clsC[1],clsC[2])
	
End Function

Function Credits()
	RenderWorld()
	ClsColor(255,255,255)
	Cls
	Color(0,0,0)
	Text(gfx_w*.5, gfx_h*.5, "Music from Anitek @freemusicarchive.org", True, True)
	Text(gfx_w*.5, gfx_h*.5+20, "http://freemusicarchive.org/music/Anitek/", True, True)
	Text(gfx_w*.5, gfx_h*.5+40, "CC: by-nc-sa 3.0", True, True)
	Flip(0)
	Delay(3000)
	FlushKeys()
	FlushMouse()
End Function

;~IDEal Editor Parameters:
;~C#Blitz3D