Rem
	
	Project:	Welcome to the Matrix - BCC#58 Demo
	Author:	skey-z
	Description:
			Enter the real Matrix ;)
	
EndRem

SuperStrict

SeedRnd MilliSecs()

'System_Preset_______________

'Window
Local gWidth:Int = 800
Local gHeight:Int = 600
Local gTimer:TTimer = CreateTimer(60)
Local gQuit:Byte

'Matrix
Local sizeX:Int = 10
Local sizeY:Int = 15
Local cols:Int = gWidth/sizeX
Local rows:Int = gHeight/sizeY
Local initMatrix:Byte = True

Local cursor:Float[cols, 2]
For Local x:Int = 0 To cols-1
	cursor[x,0] = -sizeX
	cursor[x,1] = 1
Next

Local matrix:Int[cols, rows]

Local matrixAlpha:Float[cols, rows]

'Sound
Local matrixSFX:TSound = LoadSound("media/Through_the_Matrix.ogg", SOUND_LOOP)

'Time
Local timeStart:Int = MilliSecs()
'____________________________


'Init_Graphics_______________
Graphics gWidth, gHeight
SetBlend(ALPHABLEND)
PlaySound matrixSFX
'____________________________

While Not gQuit
	
	WaitTimer gTimer
	Local timeThis:Int = MilliSecs()
	
	'Input______________________
		If KeyHit(KEY_ESCAPE) Or AppTerminate() Then gQuit = True
	'___________________________
	
	'Update_____________________
			
		If (timeThis-timeStart) > (initMatrix*2) Then
			For Local x:Int = 0 To cols-1
				cursor[x,0] :+ cursor[x,1]
				
				If (cursor[x,0] Mod sizeY) = 0 Then
					Local y:Int = (cursor[x,0]/sizeY)
					If (y >= 0) And (y < rows) Then
						matrix[x,y] = Rand(32,255)
						matrixAlpha[x,y] = 1
						TTrail.Create(x,y)
					EndIf
				EndIf
				
				If initMatrix Then
					If (cursor[x,0] > gHeight) Then
						If (x=cols-1)
							initMatrix = False
						EndIf
						cursor[x,0] = -sizeY*Rand(5,25)
						cursor[x,1] = Rand(1,5)
					EndIf
				Else
					If cursor[x,0] > (gHeight+sizeY*Rand(2,5)) Then
						cursor[x,0] = -sizeY*Rand(5,25)
						cursor[x,1] = Rand(1,5)
					EndIf
				EndIf
			Next
			timeStart = MilliSecs()
		EndIf
		
		For Local y:Int = 0 To rows-1
			For Local x:Int = 0 To cols-1
				If (matrixAlpha[x,y] > 0) Then
					If Not initMatrix Then	matrixAlpha[x,y] :- .01
				EndIf
			Next
		Next
	'___________________________
	
	'Draw_______________________
		
		TTrail.Draw(sizeX, sizeY)
		
		SetColor(255, 255, 255)
		SetAlpha(1)
		For Local x:Int = 0 To cols-1
			DrawRect x*sizeX, cursor[x,0], sizeX, sizeY
		Next
		
		SetColor(64, 255, 32)
		For Local y:Int = 0 To rows-1
			For Local x:Int = 0 To cols-1
				SetAlpha(matrixAlpha[x,y])
				DrawText Chr(matrix[x,y]), x*sizeX, y*sizeY
			Next
		Next
		
		If initMatrix Then
			SetColor(255, 0, 0)
			SetAlpha(1)
			DrawText "Scanning Matrix Data", 1*sizeX, cursor[0,0]
		EndIf
	'___________________________

	Flip 0
	Cls
Wend

End


'Read_Script_____________________________________
'________________________________________________
Function Script:Int(path:String)
End Function
'________________________________________________
'________________________________________________

'TRAILS__________________________________________
'________________________________________________
Type TTrail
	'List
	Global _trailList:TList = CreateList()
	Field _trailLink:TLink
	
	'Attributes
	Field _x:Int, _y:Int
	Field _alpha:Float = 1
	
	'OnCreate
	Method New()
		_trailLink = _trailList.AddLast(Self)
	End Method
	
	'Create Object
	Function Create:TTrail(x:Int, y:Int)
		Local trail:TTrail = New TTrail
			trail._x = x
			trail._y = y
	End Function
	
	'Update Object
	Method Update()
		Self._alpha :- .05
		If Self._alpha <= 0 Then Self.Remove()
	End Method
	
	'Draw Objects
	Function Draw:TTrail(w:Int, h:Int)
		For Local trail:TTrail = EachIn TTrail._trailList
			SetColor(255, 255, 255)
			SetAlpha(trail._alpha)
			DrawRect trail._x*w, trail._y*h, w, h
			
			trail.Update()
		Next
	End Function
	
	'Count Objects
	Function Count:Int()
		Local index:Int
		For Local trail:TTrail = EachIn TTrail._trailList
			index :+ 1
		Next
		Return index
	End Function
	
	
	'Delete all Object
	Function Clear:TTrail()
		For Local trail:TTrail = EachIn TTrail._trailList
			trail.Remove()
		Next
	End Function
	
	'Delete Objects
	Method Remove()
		_trailLink.Remove()
	End Method
		
End Type
'________________________________________________
'________________________________________________
